org.apache.xerces.dom

## Class CharacterDataImpl

- java.lang.Object
- - org.apache.xerces.dom.NodeImpl
  - - org.apache.xerces.dom.ChildNode
    - - org.apache.xerces.dom.CharacterDataImpl

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, org.w3c.dom.events.EventTarget, org.w3c.dom.Node, org.w3c.dom.NodeList
  Direct Known Subclasses:
    CommentImpl, ProcessingInstructionImpl, TextImpl

      public abstract class CharacterDataImpl
      extends ChildNode

  CharacterData is an abstract Node that can carry character data as its Value. It provides shared behavior for Text, CData, and possibly other node types. All offsets are 0-based.

  Since ProcessingInstructionImpl inherits from this class to reuse the setNodeValue method, this class isn't declared as implementing the interface CharacterData. This is done by relevant subclasses (TexImpl, CommentImpl).

  This class doesn't directly support mutation events, however, it notifies the document when mutations are performed so that the document class do so.

  Since:
    PR-DOM-Level-1-19980818.
  Version:
    $Id: CharacterDataImpl.java 1057477 2011-01-11 03:32:03Z mrglavas $
  See Also:
    Serialized Form

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `data`

    - ### Fields inherited from class org.apache.xerces.dom.ChildNode

      `nextSibling, previousSibling`

    - ### Fields inherited from class org.apache.xerces.dom.NodeImpl

      `DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_IS_CONTAINED, DOCUMENT_POSITION_PRECEDING, ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, ID, IGNORABLEWS, NORMALIZED, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, TREE_POSITION_ANCESTOR, TREE_POSITION_DESCENDANT, TREE_POSITION_DISCONNECTED, TREE_POSITION_EQUIVALENT, TREE_POSITION_FOLLOWING, TREE_POSITION_PRECEDING, TREE_POSITION_SAME_NODE`

    - ### Fields inherited from interface org.w3c.dom.Node

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `CharacterDataImpl()`
    `protected` | `CharacterDataImpl(CoreDocumentImpl ownerDocument, java.lang.String data)` Factory constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendData(java.lang.String data)` Concatenate additional characters onto the end of the data stored in this node.
    `void` | `deleteData(int offset, int count)` Remove a range of characters from the node's value.
    `org.w3c.dom.NodeList` | `getChildNodes()` Returns an empty node list.
    `java.lang.String` | `getData()` Retrieve character data currently stored in this node.
    `int` | `getLength()` Report number of characters currently stored in this node's data.
    `java.lang.String` | `getNodeValue()` Returns the node value.
    `void` | `insertData(int offset, java.lang.String data)` Insert additional characters into the data stored in this node, at the offset specified.
    `void` | `replaceData(int offset, int count, java.lang.String data)` Replace a series of characters at the specified (zero-based) offset with a new string, NOT necessarily of the same length.
    `void` | `setData(java.lang.String value)` Store character data into this node.
    `void` | `setNodeValue(java.lang.String value)` Sets the content, possibly firing related events, and updating ranges (via notification to the document)
    `protected void` | `setNodeValueInternal(java.lang.String value)` Convenience wrapper for calling setNodeValueInternal when we are not performing a replacement operation
    `protected void` | `setNodeValueInternal(java.lang.String value, boolean replace)` This function added so that we can distinguish whether setNodeValue has been called from some other DOM functions.
    `java.lang.String` | `substringData(int offset, int count)` Substring is more than a convenience function.

    - ### Methods inherited from class org.apache.xerces.dom.ChildNode

      `cloneNode, getNextSibling, getParentNode, getPreviousSibling`

    - ### Methods inherited from class org.apache.xerces.dom.NodeImpl

      `addEventListener, appendChild, changed, changes, compareDocumentPosition, compareTreePosition, dispatchEvent, getAttributes, getBaseURI, getContainer, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNodeName, getNodeNumber, getNodeType, getOwnerDocument, getPrefix, getReadOnly, getTextContent, getUserData, getUserData, getUserDataRecord, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, item, lookupNamespaceURI, lookupPrefix, needsSyncChildren, normalize, removeChild, removeEventListener, replaceChild, setOwnerDocument, setPrefix, setReadOnly, setTextContent, setUserData, setUserData, synchronizeData, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### data

          protected java.lang.String data

  - ### Constructor Detail

    - #### CharacterDataImpl

          public CharacterDataImpl()

    - #### CharacterDataImpl

          protected CharacterDataImpl(CoreDocumentImpl ownerDocument,
                           java.lang.String data)

      Factory constructor.

  - ### Method Detail

    - #### getChildNodes

          public org.w3c.dom.NodeList getChildNodes()

      Returns an empty node list.
      Specified by:
        `getChildNodes` in interface `org.w3c.dom.Node`
      Overrides:
        `getChildNodes` in class `NodeImpl`

    - #### getNodeValue

          public java.lang.String getNodeValue()

      Description copied from class: `NodeImpl`
      Returns the node value.
      Specified by:
        `getNodeValue` in interface `org.w3c.dom.Node`
      Overrides:
        `getNodeValue` in class `NodeImpl`

    - #### setNodeValueInternal

          protected void setNodeValueInternal(java.lang.String value)

      Convenience wrapper for calling setNodeValueInternal when we are not performing a replacement operation

    - #### setNodeValueInternal

          protected void setNodeValueInternal(java.lang.String value,
                                  boolean replace)

      This function added so that we can distinguish whether setNodeValue has been called from some other DOM functions. or by the client.

      This is important, because we do one type of Range fix-up, from the high-level functions in CharacterData, and another type if the client simply calls setNodeValue(value).

    - #### setNodeValue

          public void setNodeValue(java.lang.String value)

      Sets the content, possibly firing related events, and updating ranges (via notification to the document)
      Specified by:
        `setNodeValue` in interface `org.w3c.dom.Node`
      Overrides:
        `setNodeValue` in class `NodeImpl`

    - #### getData

          public java.lang.String getData()

      Retrieve character data currently stored in this node.
      Throws:
        `DOMExcpetion(DOMSTRING_SIZE_ERR)` - In some implementations, the stored data may exceed the permitted length of strings. If so, getData() will throw this DOMException advising the user to instead retrieve the data in chunks via the substring() operation.

    - #### getLength

          public int getLength()

      Report number of characters currently stored in this node's data. It may be 0, meaning that the value is an empty string.
      Specified by:
        `getLength` in interface `org.w3c.dom.NodeList`
      Overrides:
        `getLength` in class `NodeImpl`
      Returns:
        int
      See Also:
        `ParentNode`

    - #### appendData

          public void appendData(java.lang.String data)

      Concatenate additional characters onto the end of the data stored in this node. Note that this, and insert(), are the paths by which a DOM could wind up accumulating more data than the language's strings can easily handle. (See above discussion.)
      Throws:
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.

    - #### deleteData

          public void deleteData(int offset,
                        int count)
                          throws org.w3c.dom.DOMException

      Remove a range of characters from the node's value. Throws a DOMException if the offset is beyond the end of the string. However, a deletion _count_ that exceeds the available data is accepted as a delete-to-end request.
      Throws:
        `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length, or if count is negative.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.
        `org.w3c.dom.DOMException`

    - #### insertData

          public void insertData(int offset,
                        java.lang.String data)
                          throws org.w3c.dom.DOMException

      Insert additional characters into the data stored in this node, at the offset specified.
      Throws:
        `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.
        `org.w3c.dom.DOMException`

    - #### replaceData

          public void replaceData(int offset,
                         int count,
                         java.lang.String data)
                           throws org.w3c.dom.DOMException

      Replace a series of characters at the specified (zero-based) offset with a new string, NOT necessarily of the same length. Convenience method, equivalent to a delete followed by an insert. Throws a DOMException if the specified offset is beyond the end of the existing data.
      Parameters:
        `offset` - The offset at which to begin replacing.
        `count` - The number of characters to remove, interpreted as in the delete() method.
        `data` - The new string to be inserted at offset in place of the removed data. Note that the entire string will be inserted -- the count parameter does not affect insertion, and the new data may be longer or shorter than the substring it replaces.
      Throws:
        `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length, or if count is negative.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.
        `org.w3c.dom.DOMException`

    - #### setData

          public void setData(java.lang.String value)
                       throws org.w3c.dom.DOMException

      Store character data into this node.
      Throws:
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.
        `org.w3c.dom.DOMException`

    - #### substringData

          public java.lang.String substringData(int offset,
                                       int count)
                                         throws org.w3c.dom.DOMException

      Substring is more than a convenience function. In some implementations of the DOM, where the stored data may exceed the length that can be returned in a single string, the only way to read it all is to extract it in chunks via this method.
      Parameters:
        `offset` - Zero-based offset of first character to retrieve.
        `count` - Number of characters to retrieve. If the sum of offset and count exceeds the length, all characters to end of data are returned.
      Throws:
        `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length, or if count is negative.
        `DOMException(WSTRING_SIZE_ERR)` - In some implementations, count may exceed the permitted length of strings. If so, substring() will throw this DOMException advising the user to instead retrieve the data in smaller chunks.
        `org.w3c.dom.DOMException`

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.